//+------------------------------------------------------------------+
//|                                                        OsUSD.mq4 |
//|                                                      Raymond Toh |
//|                                           http://forex.eazel.com |
//+------------------------------------------------------------------+
#property copyright "Raymond Toh"
#property link      "http://forex.eazel.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow

//
//
//
//
//

extern int    VHF_Period = 28;
extern int    T3Period   = 5;
extern int    T3Price    = PRICE_CLOSE;
extern double T3Hot      = 0.7;
extern bool   T3Original = true;

//
//
//
//
//

double Buffer[];
double emas[][6];

//
//
//
//
//

double alpha;
double c1;
double c2;
double c3;
double c4;

//
//
//
//
//

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   
   SetIndexBuffer(0,Buffer);
   
   double a = T3Hot;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

      T3Period = MathMax(1,T3Period);
      if (T3Original)
           alpha = 2.0/(1.0 + T3Period);
      else alpha = 2.0/(2.0 + (T3Period-1.0)/2.0);

   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int limit,i;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) Buffer[i] = iT3(getVhf(VHF_Period,i),i);  
      
    
    return(0);
  }

//
//
//
//
//  
  
double getVhf(int period, int bar)
{
    double HCP = High[Highest(NULL,0,MODE_CLOSE,period,bar)];
    double LCP = Low[Lowest(NULL,0,MODE_CLOSE,period,bar)];
    double Numerator = MathAbs(HCP-LCP);
    double Denominator ;

    for(int i=bar; i<bar+period; i++)
        Denominator = Denominator + MathAbs( Close [i] - Close[i+1]) ;

     return (Numerator/Denominator);
}
  
//
//
//
//
//

double iT3(double price,int shift)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
         emas[i][3] = price;
         emas[i][4] = price;
         emas[i][5] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
         emas[i][3] = emas[i-1][3]+alpha*(emas[i][2]-emas[i-1][3]);
         emas[i][4] = emas[i-1][4]+alpha*(emas[i][3]-emas[i-1][4]);
         emas[i][5] = emas[i-1][5]+alpha*(emas[i][4]-emas[i-1][5]);
      }
   return(c1*emas[i][5] + c2*emas[i][4] + c3*emas[i][3] + c4*emas[i][2]);
}


